module.exports =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 1);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports) {

/*
 *
 * appendCrud function
 * append CRUD like methods to any object
 *
 */

module.exports = (schema, options = {}) => {
  const { idLabel = 'uid' } = options;
  return {
    get() {
      return { sucess: true, data: this.collection };
    },
    post(obj) {
      try {
        obj = this[schema](obj);
      } catch (e) {
        return { sucess: false, error: e };
      }
      this.collection = [...this.collection, obj];
      return { sucess: true, data: obj };
    },
    put(uid, _obj) {
      uid = String(uid);
      if (!this.collection.find(obj => obj[idLabel] === uid)) {
        return { sucess: false, error: 'couldnt match the uid' };
      }
      this.collection = this.collection.map(obj => {
        if (obj[idLabel] === uid) {
          obj = { ...obj, ..._obj };
        }
        return obj;
      });
      return {
        sucess: true,
        data: this.collection.find(obj => obj[idLabel] === uid)
      };
    },
    delete(uid) {
      uid = String(uid);
      if (!this.collection.find(obj => obj[idLabel] === uid)) {
        return { sucess: false, error: 'couldnt match the uid' };
      }
      this.collection = this.collection.filter(obj => obj[idLabel] !== uid);
      return { sucess: true };
    }
  };
};


/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

const { createStore } = __webpack_require__(2);

module.exports = createStore;


/***/ }),
/* 2 */
/***/ (function(module, exports, __webpack_require__) {

const createStore = __webpack_require__(3),
  appendCrud = __webpack_require__(0);

module.exports = { createStore, appendCrud };


/***/ }),
/* 3 */
/***/ (function(module, exports, __webpack_require__) {

const appendCrud = __webpack_require__(0);

/*
 *
 * createStore function
 * create a store from a specific object
 * { key: { [data], (schema), {resolvers}, {options} } }
 *
 */

module.exports = mock => {
  if ((!mock && typeof mock !== 'object') || Object.keys(mock).length === 0)
    throw new Error("No object found in 'createStore' parameter.");

  const distributedData = (data = [], schema, options) =>
    data.map((item, i) => useSchema(schema, item, i, options)); // return a mock data with an iud

  const generateSchema = (data, name) => {
    // Generate a schema based on an array of data
    if (data.length === 0)
      throw new Error(
        'Require at least one object inside the data key, with useSchema option at false.'
      );

    const objWithSchema = {
      [name]: function(params) {
        Object.entries(params).forEach(param => {
          this[param[0]] = param[1];
        });
      }
    };
    return objWithSchema[name];
  };

  const useSchema = (schema, obj, uid, options) => {
    // Generate an uid append to a schema
    const { idLabel = 'uid' } = options;

    const genUid = uid => {
      uid = String(uid);
      if (uid.length === 6) {
        return uid
          .split('')
          .reverse('')
          .join('');
      } else {
        return genUid(`${uid}${'0'.repeat(6 - uid.length)}`);
      }
    };

    return {
      ...new schema({ ...obj }),
      [idLabel]: genUid(uid)
    };
  };

  return Object.entries(mock).reduce((acc, cur) => {
    const key = cur[0]; // name
    const obj = cur[1]; // content
    const options = obj.options || { useSchema: false }; // options
    const resolvers = obj.resolvers; // resolvers

    if (options.useSchema && !obj.schema) {
      throw new Error(
        'A schema must be spcecified with useSchema option at true.'
      );
    }
    const schemaName = key
      .toLowerCase()
      .replace(/^./, str => str.toUpperCase()); // schema name
    const schema = options.useSchema
      ? obj.schema
      : generateSchema(obj.data, schemaName); // schemaless or not
    const collection = distributedData(obj.data, schema, options); // Data with uid
    return {
      ...acc,
      [key]: {
        collection,
        [schemaName]: function(obj) {
          return useSchema(schema, obj, this.collection.length, options);
        }, // Get context (db) to return an object with a generated uid
        ...appendCrud(schemaName, options), // Auto generate crud
        ...resolvers // resolvers
      }
    };
  }, {});
};


/***/ })
/******/ ]);